package com.supwisdom.dlpay.consume.service.impl

import com.supwisdom.dlpay.consume.PersonTransBuilder
import com.supwisdom.dlpay.consume.dao.AccountDao
import com.supwisdom.dlpay.consume.dao.TransdtlDao
import com.supwisdom.dlpay.consume.dao.UserdtlDao
import com.supwisdom.dlpay.consume.domain.TAccount
import com.supwisdom.dlpay.consume.domain.TUserdtl
import com.supwisdom.dlpay.consume.service.AccountUtilServcie
import com.supwisdom.dlpay.consume.service.PersonBalancePayService
import com.supwisdom.dlpay.exception.TransactionProcessException
import com.supwisdom.dlpay.framework.domain.TShopacc
import com.supwisdom.dlpay.framework.domain.TSubject
import com.supwisdom.dlpay.framework.domain.TTranstype
import com.supwisdom.dlpay.framework.service.SystemUtilService
import com.supwisdom.dlpay.framework.util.DateUtil
import com.supwisdom.dlpay.framework.util.TradeCode
import com.supwisdom.dlpay.framework.util.TradeDict
import com.supwisdom.dlpay.framework.util.TradeErrorCode
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.stereotype.Service
import javax.persistence.EntityManager
import javax.persistence.PersistenceContext


@Service
class AccountUtilServcieImpl : AccountUtilServcie {

    override fun readAccountForUpdate(userid: String, nowait: Boolean): TAccount {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }

    override fun readAccount(userid: String): TAccount {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }

    override fun readShopAccForUpdate(shopId: String, nowait: Boolean): TShopacc {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }

    override fun readShopAcc(shopId: String): TShopacc {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }

    override fun readSubjectForUpdate(subjno: String, nowait: Boolean): TSubject {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }

    override fun readSubject(subjno: String): TSubject {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }

    override fun readTranstype(transtype: Int): TTranstype {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }
}

@Service
class PersonBalancePayServiceImpl : PersonBalancePayService {
    @Autowired
    lateinit var userdtlDao: UserdtlDao
    @Autowired
    lateinit var systemUtilService: SystemUtilService

    @Autowired
    lateinit var accountDao: AccountDao

    @PersistenceContext
    lateinit var em: EntityManager

    private fun lockAccount(builder: PersonTransBuilder): TAccount {
        TODO("")
    }

    override fun process(builder: PersonTransBuilder): TUserdtl {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }

    override fun init(builder: PersonTransBuilder): TUserdtl {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
        lateinit var userdtl: TUserdtl
        var refno = systemUtilService.refno
        var systemtime  = systemUtilService.sysdatetime
        userdtl.refno = refno
        userdtl.amount = builder.amount
        userdtl.createtime = systemtime.hostdatetime
        userdtl.status =  TradeDict.DTL_STATUS_INIT
        userdtlDao.save(userdtl)
        return userdtl
    }

    override fun wip(paydtl: TUserdtl, builder: PersonTransBuilder): TUserdtl {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }

    override fun wip(refno: String, builder: PersonTransBuilder): TUserdtl {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }

    override fun finish(paydtl: TUserdtl, status: String, builder: PersonTransBuilder): TUserdtl {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }

    override fun finish(refno: String, status: String, builder: PersonTransBuilder): TUserdtl {
        userdtlDao.findById(refno).let {
            if (it.isPresent) {
                return finish(it.get(), status, builder)
            }
            throw TransactionProcessException(TradeErrorCode.TRANSACTION_NOT_EXISTS, "交易参考号<$refno>不存在")
        }
    }


}